/* AppController */

#import <Cocoa/Cocoa.h>
#import <libpq-fe.h>
#import <Node.h>
#import <OLDataSource.h>
#import <writeReport.h>
#import <MyTableView.h>

#define ENTER_KEY_CODE 76
#define RETURN_KEY_CODE 36

@interface AppController : NSObject
{
    PGconn *connection;
    PGresult *lastResult;
    PGresult *typeResult;
    IBOutlet NSWindow *mainWindow;
    IBOutlet NSTextView *inputTextView;
    IBOutlet NSTextView *outputTextView;
	
    
    IBOutlet NSTextField *userTextField;
    IBOutlet NSTextField *passwordTextField;
    IBOutlet NSTextField *hostTextField;
    IBOutlet NSTextField *dbTextField;
    IBOutlet NSWindow *loginSheet;
	IBOutlet NSMenuItem *displayNULL;
    id progressIndicator;
    
    IBOutlet MyTableView *tableView;
	IBOutlet NSMenuItem * showHideItem;
	IBOutlet NSMenu * scriptMenu;
	
    NSMutableArray *executedStatements;
    int currentIndex;
	
	IBOutlet NSOutlineView *outlineView;  // ref to the outline view showing tables
	OLDataSource *outlineViewController;   // ref to outline view object
	
	id myWriter;      // pointer to the file writer class
	IBOutlet NSMenuItem *sendSingleStatements;		// ref to menu item
	NSUserDefaults * prefs;					// initially login defaults
	NSFont *tableViewFont;					// font in use in table view
	
}
- (void)appendToLog:(NSString *)s color:(NSColor *)c;
- (IBAction)reconnect:(id)sender;
- (IBAction)execute:(id)sender;
- (IBAction)connect:(id)sender;
- (IBAction)previous:(id)sender;
- (IBAction)next:(id)sender;
- (IBAction)open:(id)sender;
- (IBAction)refresh:(id)sender;
- (IBAction)updateScriptsMenu:(id)sender;
- (NSString *)typeNameForOID:(Oid)typeOID;
- (IBAction)quit:(id)sender;
- (void)registerToolTipHandler;
- (IBAction)saveSelection:(id)sender;
- (IBAction)openScriptsDir:(id)sender;
- (void)openDraggedFile:(NSString*) theFile;
- (void)showSelTable;
- (void)buildScriptMenu:(NSMenu*) theMenu;
- (void)extendScriptMenu:(NSMenu*) menu withPath:thePath;
- (IBAction)showHideSystemTables:(id)sender;
- (IBAction)loadScript:(id)sender;
- (IBAction)saveEditWindow:(id)sender;
- (IBAction)displayNullField:(id)sender;

-(void)whereAmI;    // experimental...try to locate the row and column of doubleclick
-(NSArray *) parseInput: (NSString *) statementString; 
- (BOOL)textView:(NSTextView *)textView doCommandBySelector:(SEL)commandSelector;
- (void)sendSingleStatements:(id)sender;
-(IBAction)setEditWindowFont:(id)sender;
-(IBAction)setTableViewFont:(id)sender;
-(void) firstTableViewSetup:(NSFont*)aFont;

@end
