//
//  MyTextView.m
//  BiggerSQL
//
//  Created by Jerry LeVan on Sat Feb 21 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "MyTextView.h"

@implementation MyTextView

-(void)awakeFromNib  // register for the type of pasteboard we are interested in
{
 // Actually it appears that TextView already does the registration...
 [self registerForDraggedTypes:
        [NSArray arrayWithObject:NSFilenamesPboardType]]; 
 }
 
-(NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender
{  
  if([sender draggingSource]!= self) {
     NSPasteboard *pb = [sender draggingPasteboard];
     NSString *type = [pb availableTypeFromArray:
                         [NSArray arrayWithObject: NSFilenamesPboardType]];
    if(type !=nil) { 
      [self lockFocus];
      NSRect theFrame = [self bounds];
      [[NSColor keyboardFocusIndicatorColor] set];
      NSBezierPath *thePath = [NSBezierPath bezierPathWithRect:theFrame];
      [thePath setLineWidth:5];
      [thePath stroke];
      [[NSApp mainWindow] flushWindow];
      [self unlockFocus];
	  return NSDragOperationEvery;
    }
  }
    return NSDragOperationEvery;
}

-(BOOL) prepareForDragOperation: (id <NSDraggingInfo>)sender
{
 // NSLog(@"TF:Preparing");
  return YES;
}

-(void) draggingExited:(id <NSDraggingInfo>)sender
{
  // NSLog(@"TF:draggingExited");
   [self setNeedsDisplay:YES];
}

-(BOOL) performDragOperation:(id <NSDraggingInfo>)sender
{
    NSPasteboard *pboard;
    NSDragOperation sourceDragMask;
   // NSLog(@"TF:Doing Drop");
    sourceDragMask = [sender draggingSourceOperationMask];
    pboard = [sender draggingPasteboard];

   if ( [[pboard types] containsObject:NSFilenamesPboardType] ) {
        NSArray *files = [pboard propertyListForType:NSFilenamesPboardType];
        [self setString:[NSString stringWithContentsOfFile:[files objectAtIndex:0]]];
        [self setNeedsDisplay:YES];
        [[NSApp mainWindow] flushWindow];
    }	
    return YES;
}
-(void) concludeDragOperation:(id <NSDraggingInfo>)sender
{
//  NSLog(@"TF:In conclude"); 
  NSPasteboard *pboard;
  // We have already handled writting the file, let super handle everything else...
  // Thanks to Satoshi Matsumoto for the clue :)
  pboard = [sender draggingPasteboard];
  if(! [[pboard types] containsObject:NSFilenamesPboardType] ) [super concludeDragOperation:sender];
}

-(NSDragOperation)draggingUpdated:(id <NSDraggingInfo>)sender
{
 // This routine is evidently essential...
 // NSLog(@"Drag Updated");
  return NSDragOperationEvery;
}
-(void)changeFont:(id)sender
{
   NSFont *oldFont =[self font];
 //  NSLog(@"editwindow font:%@", oldFont);
   NSFont *newFont = [sender convertFont:oldFont];
   [self setFont:newFont];
   // record the new font in the defaults
   NSData* inputFontAsData = [NSKeyedArchiver archivedDataWithRootObject:newFont];
   [[NSUserDefaults standardUserDefaults] setObject:inputFontAsData forKey:@"BSQLinputFont" ];
}

@end
