//
//  Node.m

#import "Node.h"


@implementation Node
- (id)init
{
    [super init];
    children = [[NSMutableArray alloc] init];
    return self;
}
- (void)setItemName:(NSString *)s
{
    [s retain];
    [itemName release];
    itemName = s;
}

- (void)setItemInfo:(NSString *)s
{
    [s retain];
    [itemInfo release];
    itemInfo = s;
}

- (void)setMoreItemInfo:(NSString*)s
{
   [s retain];
   [moreItemInfo release];
   moreItemInfo = s;
}

- (NSString *)itemName
{
    return itemName;
}

-(NSString *)itemInfo
{
  return itemInfo;
}

-(NSString *)moreItemInfo
{
  return moreItemInfo;
}

- (void)addChild:(Node *)n
{
    [children addObject:n];
}
- (Node *)childAtIndex:(int)i
{
    return [children objectAtIndex:i];
}
- (int)childrenCount
{
    return [children count];
}
- (BOOL)expandable
{
    return ([children count] > 0);
}

- (void)dealloc
{
    [children release];
	//NSLog(@"Releasing:%@",itemName);
    [itemName release];
	[itemInfo release];
	[moreItemInfo release];
    [super dealloc];
}
@end
