#import <Cocoa/Cocoa.h>
#import "Node.h"
#import <libpq-fe.h>

@interface OLDataSource : NSObject
{
    // I am the data source of this outline view
    IBOutlet NSOutlineView *outlineView;
	
    // This is the connection to the database and associated variables
	PGconn *connection;
	PGresult *theResult;
	
    // This node is the root of the tree being displayed
    Node *rootNode;
	
	// value of the show system table menu item
	int menuState;
}

// This is the method triggered by the button
- (IBAction)addChild:(id)sender;

// custom initializer
-(id)initWithConnections: (PGconn*)theConnection
			theView: (id) tableOutline
			menuState:(int) showTable;
				
-(void)buildTableList:(Node*) theNode;
-(void)buildTableInfo:(Node*) theNode;
					 
// These methods get called because I am the datasource of 
// the outline view.
- (id)outlineView:(NSOutlineView *)outlineView 
    child:(int)index 
    ofItem:(id)item;
- (BOOL)outlineView:(NSOutlineView *)outlineView 
    isItemExpandable:(id)item;
- (int)outlineView:(NSOutlineView *)outlineView 
    numberOfChildrenOfItem:(id)item;
- (id)outlineView:(NSOutlineView *)outlineView 
    objectValueForTableColumn:(NSTableColumn *)tableColumn 
    byItem:(id)item;

@end
