//
//  writeReport.h
//  BiggerSQL
//
//  Created by Jerry LeVan on Sat Feb 21 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <libpq-fe.h>
#import <stdio.h>

@interface writeReport : NSObject {

   //Pointer to the output dialog window
    IBOutlet id outputWindow;

    //  CSV output file options...
    IBOutlet id outputSeperatorTextField;  
    IBOutlet id wrapOutputItemRadio;
    IBOutlet id outputLineEnding;
	IBOutlet id includeHeader;
	
	// Aligned text output file option
	IBOutlet id alignedIncludeHeader;
	IBOutlet id alignedBoxItems;
	IBOutlet id alignedItemSeperatorTextField;
	IBOutlet id alignedExpandedTable;
	
	// HTML output file options
	IBOutlet id htmlIncludeHeader;
	IBOutlet id htmlExpandedTable;
	IBOutlet id htmlCaptionTextField;
	IBOutlet id htmlTableOptionsTextField;


    NSMutableString *outEol;    // output file line seperator
    NSMutableString *outSep;    // output file item seperator
    unsigned itemWrap;          // 0->do nothing 1->strip enclosing quotes 2-> add enclosing quotes

    Boolean writeTheFile;       // horrible kludge...
    Boolean writeAlignedFile;
	Boolean writeHTMLFile;      // end of kludge
	
	NSString * outputFile;        // path name of file to be written


}
  // called when user clicks on the save selection menu in the main window 
- (void) saveAction: (PGresult *)theResult;

  // pops up dialog to get output parameter for file writing, called from saveAction
- (void)getOutputParameters;

-(Boolean)writeFile:   (NSString *)          fName 
           queryRes:   (PGresult* )          pgRes
           theItemSep: (NSMutableString*)    fSep
           theLineSep: (NSMutableString*)    fEol
           wrapInfo:   (unsigned)            wrapProtocol;

-(Boolean) writeAlignedTextFile : (NSString *) fname
			queryRes: (PGresult*) pgRes;

-(Boolean) writeHTMLTextFile: (NSString*) fname queryRes: (PGresult*) pgres;
		    
  // The Output options dialog has two buttons OK and Cancel
  // When the user clicks OK in the OutputOptions dialog
- (IBAction)getOutputOptions:(id)sender;
  // when the user clicks OK in the AlignedText window
-(IBAction)alignedWriteOK:(id)sender;  
  // when the user clicks OK in the HTML window
-(IBAction)htmlOK:(id)sender;

  // when the user clicks Cancel in the output options dialog
- (IBAction) cancelOutputAction:(id)sender;

@end
