//
//  writeReport.m
//  BiggerSQL
//
//  Created by Jerry LeVan on Sat Feb 21 2004.
//  Copyright (c) 2004 __MyCompanyName__. All rights reserved.
//

#import "writeReport.h"


@implementation writeReport
-(id) init
{
  [super init];
   outSep = [[NSMutableString alloc] init];
   outEol = [[NSMutableString alloc] init];
   [outSep retain];
   [outEol retain];
   return self;
}

 - (void)saveAction:(PGresult*)results  // clicked the save button in choose file window
 {
 
  //Step 1, get the filename for output
  NSSavePanel * panel= [NSSavePanel savePanel];
  if( [panel runModal] ==NSFileHandlingPanelOKButton){
   outputFile =   [NSString stringWithString:[panel filename]]; //  need to use "files"?
   [outputFile retain];
  }else return;
  
  // Step 2, putup the output parameters dialog
  // Depending on which options the user chooses, at most one
  // (and possibly none) of the following will be set to YES
  writeTheFile=NO;
  writeAlignedFile=NO;
  writeHTMLFile=NO;
  
  [self getOutputParameters];
  
  // step three write the file or not?
 // if(writeTheFile==NO) {
   // NSLog(@"user cancelled file save");
  //  return;
  // }
  // Dump the array to the file
  
  if(writeTheFile==YES) 
     [self writeFile: outputFile
           queryRes:   results
           theItemSep: outSep
           theLineSep: outEol
           wrapInfo:   itemWrap ] ;
		   
  if(writeAlignedFile==YES)
      [self writeAlignedTextFile: outputFile queryRes:results];
	  
  if(writeHTMLFile==YES)
	  [self writeHTMLTextFile: outputFile queryRes:results];
 }
  
 -(void)getOutputParameters   // called from with the saveAction routine,displays dialog
 {
 if (!outputWindow)
     if(![NSBundle loadNibNamed: @"OutputOptions2" owner: self])
        NSLog(@"Error Loading Nib File");  // need an alert here
       // NSLog(@"remote window->%@",remoteWindow);
 [NSApp beginSheet: outputWindow
            modalForWindow: [NSApp mainWindow]
            modalDelegate: nil
            didEndSelector: nil
            contextInfo: nil];
  [NSApp runModalForWindow: outputWindow];
  // Sheet is up here.
  // NSLog(@"run modal just executed");
  [NSApp endSheet:outputWindow];  //required!
  [outputWindow orderOut: self];

 }
 
 -(IBAction) getOutputOptions:(id)sender  // clicked OK in output options dialog CSV pane
 {
    // get the item seperator character
  [outSep  setString: [outputSeperatorTextField stringValue]]; 
  if([ outSep isEqualToString:@"\\t"]) [outSep setString: @"\t" ];
  [outSep retain];
    
  // determine the item wrapping
  switch([wrapOutputItemRadio selectedRow])
  {
    case 0: itemWrap=0; break;
    case 1: itemWrap=1; break;
    case 2: itemWrap=2; break;
  }
  
  // Determine the type of endings the output file has....
  switch ([outputLineEnding selectedRow])
  {
    case 0: [outEol setString: @"\n"]; break;
    case 1: [outEol setString: @"\r"]; break;
    case 2: [outEol setString: @"\r\n"] ; break;
  }
  writeTheFile=YES; // Get rid of this!
  
  //NSLog(@"Include State: %d",[includeHeader state]);
  
  [NSApp stopModal];
 }
 
 - (IBAction)cancelOutputAction:(id)sender  // clicked cancel in output options dialog
 {
 [NSApp stopModal];
 }
 
 // Attempt to write the file to disk
 -(Boolean)writeFile:  (NSString *)          fName 
           queryRes:   (PGresult*)           pgRes
           theItemSep: (NSMutableString*)    fSep
           theLineSep: (NSMutableString*)    fEol
           wrapInfo:   (unsigned)            wrapProtocol

{
unsigned rowCount, colCount, i,j;
NSMutableString *tmpString, *outString;
NSCharacterSet *aQuote =[NSCharacterSet characterSetWithCharactersInString:@"\""];
Boolean result;

   rowCount=PQntuples(pgRes);
   colCount=PQnfields(pgRes);
   tmpString = [[NSMutableString alloc] init];
   outString = [[NSMutableString alloc] init];
   
   // Sigh, kludey way to handle the header....
   if([includeHeader state])
   {
      for(j=0; j<colCount;j++){
     
	   [tmpString setString:[NSString stringWithUTF8String:PQfname(pgRes,j)]];
		  
       switch(wrapProtocol){
          case 0: break;  // do nothing
          case 1: [tmpString setString: [tmpString  stringByTrimmingCharactersInSet:aQuote]];
                  break;  // string quotes
          case 2: [tmpString insertString:@"\"" atIndex:0];
                  [tmpString appendString:@"\""];
                  break;  // add quotes
         }
       
       [outString appendString: tmpString];
       // don't put field terminator after last field item
       if (j != (colCount-1)) {
         [outString appendString:fSep];
        }        
      }
	  [outString appendString:fEol];
	}
   
   // build a big string with the file contents
   for(i=0; i< rowCount ; i++) {
     for ( j=0; j< colCount;j++) {
     
	   [tmpString setString:[NSString stringWithUTF8String:PQgetvalue(pgRes,i,j)]];
		  
       switch(wrapProtocol){
          case 0: break;  // do nothing
          case 1: [tmpString setString: [tmpString  stringByTrimmingCharactersInSet:aQuote]];
                  break;  // string quotes
          case 2: [tmpString insertString:@"\"" atIndex:0];
                  [tmpString appendString:@"\""];
                  break;  // add quotes
         }
       
       [outString appendString: tmpString];
       // don't put field terminator after last field item
       if (j != (colCount-1)) {
         [outString appendString:fSep];
        }        
      }   
      // finished with the ith row, tack on the eol object
      [outString appendString:fEol];
    }
    
    // write the string to the desired file
    if(result=[outString writeToFile:fName atomically:NO]){
     [tmpString setString:@"Write was successfull!"];
     }
     else {
      [tmpString setString:@"Write Failed!"]; 
      }
    // Tell the user what happened  
    NSRunInformationalAlertPanel(@"Status Of Save Operation",tmpString,@"OK",nil,nil);
    
    [outString release];
    [tmpString release];
    
    return result;
   
}

// User clicked the OK button in the HTML options
-(IBAction)alignedWriteOK:(id)sender
{
  writeAlignedFile=YES;
  [NSApp stopModal];
}

-(IBAction)htmlOK:(id)sender
{
  writeHTMLFile=YES;
  [NSApp stopModal];
}

-(Boolean)writeAlignedTextFile: (NSString*) fname queryRes: (PGresult*)pgRes
{
  
  PQprintOpt myPrintOps;
  myPrintOps.header= [alignedIncludeHeader state]?1:0;   // include header
  myPrintOps.standard = [alignedBoxItems state]?1:0;     // box items
  myPrintOps.align = 1;                                  // allways align
  myPrintOps.html3 = 0;									 // no html out
  myPrintOps.pager = 0;									 // no pager
  myPrintOps.expanded= [alignedExpandedTable state]?1:0; // row or column expansion

  [outSep  setString: [alignedItemSeperatorTextField stringValue]]; 
  if([ outSep isEqualToString:@"\\t"]) [outSep setString: @"\t" ];
  myPrintOps.fieldSep = (char*)[outSep UTF8String];
  myPrintOps.tableOpt ="";
  myPrintOps.caption = "";
  myPrintOps.fieldName=NULL;
  
  FILE * f = fopen([fname UTF8String], "w");
  if(!f)
     NSRunInformationalAlertPanel(@"Failed to open ",fname,@"OK",nil,nil);
  PQprint(f, pgRes, &myPrintOps);	
  fclose(f);
  NSRunInformationalAlertPanel(@"Write Complete ",fname,@"OK",nil,nil);
  return YES;
}

-(Boolean) writeHTMLTextFile:(NSString*) fname queryRes: (PGresult*)pgRes
{
  PQprintOpt myPrintOps;
  myPrintOps.header= [htmlIncludeHeader state]?1:0;   // include header
  myPrintOps.standard = 0;     // not relevent for this call
  myPrintOps.align = 1;		   // not relevent for this call
  myPrintOps.html3 = 1;		   //  html out
  myPrintOps.pager = 0;
  myPrintOps.fieldSep = "";
  myPrintOps.expanded= [htmlExpandedTable state]?1:0; // row or column expansion
  myPrintOps.caption = (char*)[[htmlCaptionTextField stringValue] UTF8String];
  myPrintOps.tableOpt =(char*)[[htmlTableOptionsTextField stringValue] UTF8String];
  myPrintOps.fieldName = NULL;  
  
    FILE * f = fopen([fname UTF8String], "w");
  if(!f)
     NSRunInformationalAlertPanel(@"Failed to open ",fname,@"OK",nil,nil);
  PQprint(f, pgRes, &myPrintOps);	
  fclose(f);
  NSRunInformationalAlertPanel(@"Write Complete ",fname,@"OK",nil,nil);

 //  NSLog(@" writeing %@ as html",fname);
   return YES;
}

@end
